import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.image.BufferedImage;

/**
 * Write a description of class Mode7 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mode7 extends World
{
    GreenfootImage g = new GreenfootImage("brick.jpg");
    int height = 200;
    int x = 50;
    int y = 50;
    int z = 50;
    BufferedImage graphics;
    boolean[][][] hit = new boolean[100][100][100];
    double rotation = 0;
    int[] ground;
    /**
     * Constructor for objects of class Mode7.
     * 
     */
    public Mode7()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(400, 400, 1); 
        g.scale(1000,1000);
        graphics = getBackground().getAwtImage();
        ground = g.getAwtImage().getRGB(0,0,1000,1000,ground,0,1000);
        draw();
    }
    public void draw()
    {
        long time = System.currentTimeMillis();
        getBackground().setColor(Color.white);
        getBackground().fill();
        double sine = Math.sin(rotation);
        double cosine = Math.cos(rotation);
        for(int i=0;i<400;i++)
        for(int j=201;j<400;j++)
        {
            double pixelY2 = (200*height)/(j-200);
            double pixelX2 = ((i-200)*(pixelY2))/200;
            double pixelY = y + (cosine*pixelY2-sine*pixelX2);
            double pixelX = x + (sine*pixelY2+cosine*pixelX2);
            while(pixelX<0) pixelX += 1000;
            while(pixelY<0) pixelY += 1000;
            graphics.setRGB(i,j,ground[(int)(pixelX)%1000 + 1000*((int)(pixelY)%1000)]);
        }
        getBackground().setColor(Color.red);
        time = System.currentTimeMillis()-time;
        getBackground().drawString(time+"",50,50);
    }
    public void act()
    {
        draw();
        if(Greenfoot.isKeyDown("up"))
            y+= 3;
        else if(Greenfoot.isKeyDown("down"))
            y-=3;
        else if(Greenfoot.isKeyDown("left"))
            x-=3;
        else if(Greenfoot.isKeyDown("right"))
            x+= 3;
        else if(Greenfoot.isKeyDown("a"))
            rotation-=.03;
        else if(Greenfoot.isKeyDown("d"))
            rotation+= .03;
    }
}
